package be.iminds.ilabt.jfed.espec.filefetcher;

import be.iminds.ilabt.jfed.util.DataConversionUtils;

import java.util.Random;

/**
 * RandomDataGenerator This generates random data for the FileFetcher
 *
 * (KeyPairs are not generated in this way, see Experiment for them)
 */
public class RandomDataGenerator {
    private static Random random = new Random();

    public static String generatePassword(int byteLen) {
        //lots of chars, minus chars that look somewhat alike (o0O Il)
        String base = "abcdefghijkmnpqrstuvwxyzABCDEFGHIJKMNPQRSTUVWXYZ123456789_%!-&*^$#@=+()[]<>?";
        return generateCharsFromBase(base, byteLen);
    }

    public static String generateBase64(int encodedByteLen) {
        byte[] res = new byte[encodedByteLen];
        random.nextBytes(res);
        return DataConversionUtils.encodeBase64(res);
    }

    public static String generateAlphaNum(int byteLen) {
        String base = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        return generateCharsFromBase(base, byteLen);
    }

    public static byte[] generateBinary(int byteLen) {
        byte[] res = new byte[byteLen];
        random.nextBytes(res);
        return res;
    }


    public static String generateCharsFromBase(String base, int byteLen) {
        int baselen = base.length();
        String res = "";
        for (int i = 0; i < byteLen; i++) {
            res += base.charAt(random.nextInt(baselen));
        }
        return res;
    }
}
